const OPTION_SHORTCUT="shortcut";

var wpKeys=Array('link','bold','italic','table','image','signature','weblink');
var wpKeyParts=Array();
var wpKeyIndex=-1;

function onLoadPageShortcuts() {
	//parent.initPanel('chrome://wikipedia/content/wikipedia_preferences_shortcuts.xul');
	loadShortcuts();
}

function selectionChanged() {
	var tree=document.getElementById('shortcut-tree');
	wpKeyIndex=tree.currentIndex;
	var edit=document.getElementById('edit');
	edit.value=getFormattedKey(wpKeyParts[wpKeyIndex][0],wpKeyParts[wpKeyIndex][1],wpKeyParts[wpKeyIndex][2]);
	document.getElementById('edit').removeAttribute("disabled");
}

function getFormattedKey(modifiers,key,keycode) {
	var val=modifiers;
	if (val!="") {
		val=val+" ";
	}
	val=val+key;
	return val;
}

function updateLabel(index) {
	var label = getFormattedKey(wpKeyParts[index][0],wpKeyParts[index][1],wpKeyParts[index][2]);
	var item=document.getElementById('wp-label-'+wpKeys[index]);
	item.setAttribute("label",label);
}

function Recognize(event) {
	event.preventDefault();
	event.stopPropagation();

	var modifiers = [];
	if(event.altKey) modifiers.push("alt");
	if(event.ctrlKey) modifiers.push("control");
	if(event.metaKey) modifiers.push("meta");
	if(event.shiftKey) modifiers.push("shift");

	modifiers = modifiers.join(" ");

	var key = "";
	var keycode = "";
	if (event.charCode)
		key = String.fromCharCode(event.charCode).toUpperCase();
	else {
		keycode = gVKNames[event.keyCode];
		if(!keycode) return;
	}

	var parts=new Array(modifiers, key, keycode);
	wpKeyParts[wpKeyIndex]=parts;

	var edit=document.getElementById('edit');
	var label = getFormattedKey(modifiers,key,keycode);
	edit.value = label;
	updateLabel(wpKeyIndex);

	storeShortcuts();
}

function removeShortcut() {
	if (wpKeyIndex>-1) {
		wpKeyParts[wpKeyIndex][0]="";
		wpKeyParts[wpKeyIndex][1]="";
		wpKeyParts[wpKeyIndex][2]="";
		updateLabel(wpKeyIndex);
		storeShortcuts();
		document.getElementById('edit').value="";
	}
}

function storeShortcuts() {
	var wbPrefs = getPreferences();
	for (var i=0;i<wpKeys.length;i++) {
		var modifiers=wpKeyParts[i][0];
		var key=wpKeyParts[i][1];
		var keycode=wpKeyParts[i][2];
		wbPrefs.setCharPref(OPTION_SHORTCUT+"."+wpKeys[i]+".modifiers",modifiers);
		wbPrefs.setCharPref(OPTION_SHORTCUT+"."+wpKeys[i]+".key",key);
		wbPrefs.setCharPref(OPTION_SHORTCUT+"."+wpKeys[i]+".keycode",keycode);
	}
}

function loadShortcuts() {
	var wbPrefs = getPreferences();
	for (var i=0;i<wpKeys.length;i++) {
		var modifiers="";
		var key="";
		var keycode="";
		try {
			modifiers=wbPrefs.getCharPref(OPTION_SHORTCUT+"."+wpKeys[i]+".modifiers");
			key=wbPrefs.getCharPref(OPTION_SHORTCUT+"."+wpKeys[i]+".key");
			keycode=wbPrefs.getCharPref(OPTION_SHORTCUT+"."+wpKeys[i]+".keycode");
		}
		catch (e) {
		}
		var parts=new Array(modifiers, key, keycode);
		wpKeyParts.push(parts);
		updateLabel(i);
	}
}